
<template>
    <el-container style="height: 100%">
        <el-header>
            <commonheader></commonheader>
        </el-header>
        <el-container>
            <el-aside width="auto">
                <commonaside></commonaside>
            </el-aside>
            <el-main>
              <div class="tabControl">
                <div >
                  <el-row class="foodrow" type="flex" justify="center" >
                    <el-col :lg="12" :md="15" :sm="18" :xs="24" class="foodcol">
                      <el-card class="el-card">
                        <el-row :gutter="60" class="foodrow" type="flex" >
                          <el-col :lg="10" :xs="24" class="foodcol">
                            <img :src="shopInfo.shopImage" class="image">
                          </el-col>
                          <el-col :lg="14" :xs="24" class="foodcol">
                            <span style="text-align: center;display:block; font-size: 1.6em;">{{shopInfo.shopName}}<br></span>
                            <span style="display:block; font-size: 1.2em; width:auto;">{{'商店介绍：'+shopInfo.shopIntroduction}}</span>
                            <span style="display:block; font-size: 1.2em; width:auto;">{{'商店类型：'+shopInfo.shopType}}</span>
                            <span style="display:block; font-size: 1.2em; width:auto;">{{'商店地址：'+shopInfo.shopLocation}}</span>
                            <div style="width: 100%; text-align:right;"  v-if="islogin">
                              <el-button type="primary" size="mini" @click="goComment()">查看评论</el-button>
                              <el-button type ="success" size="mini" @click="goOrders()">管理订单</el-button>
                            </div>
                          </el-col>
                        </el-row>
                      </el-card>
                    </el-col>
                  </el-row>
                  <el-row  :gutter="20"  class="foodrow" type="flex">
                    <el-col :lg="6" :xs="24"  v-for="(item,index) in goodsList" id=item :key="item.foodID" class="foodcol">
                      <el-card class="el-card"  :key="index"  onclick="" v-if="(index >=(page.currentPage-1)*page.pageSize) && (index <(page.currentPage)*page.pageSize)" :shadow = "item.foodTakeStatus == 0 ? 'never' : 'always'" :style= "item.foodTakeStatus == 0 ? 'background-color: #f0f0f0;' : 'background-color: white' ">
                        <img :src="item.foodImage" class="image">
                        <div style="padding: 14px;">
                          <span style="text-align: center;display:block; font-size: 1em;">{{item.foodTakeStatus != 0? item.foodName : item.foodName+'[已下架]'}}<br></span>
                          <span style="display:block; font-size: 0.8em; width:auto;">{{'食品类型：'+item.foodCategory}}</span>
                          <span style="display:block; font-size: 0.8em; width:auto; ">{{'食品热量：'+item.foodCalorie+'cal'}}</span>
                          <span style="display:inline-block; width: auto; font-size: 1em; color: red;">{{'￥'+item.foodPrice}}</span>
                          <span style="display:inline-block; width: auto; font-size: 0.5em; color: grey;">{{'余量'+item.foodNumber}}</span>
                          <div style="display: block; width: 100%;">
                            <el-popover
                              placement="top-start"
                              v-for="idlable in item.ingredientList"
                              id=idlable :key="idlable.ingredientId"
                              width="auto"
                              trigger="hover">
                                <div style="padding: 14px;">
                                  <span style="text-align: center;display:block; font-size: 1em;">{{idlable.ingredientName}}<br></span>
                                  <span style="display:block; font-size: 0.8em; width:auto;">{{'食材类型：'+idlable.ingredientCategory}}</span>
                                  <span style="display:block; font-size: 0.8em; width:auto; ">{{'食材热量：'+idlable.ingredientCalorie+'cal'}}</span>
                                </div>
                              <el-button type="info" :disabled="item.foodTakeStatus == 0" plain round style="display: inline-block; width: auto; padding: 7.5px; margin-right: 3px;" slot="reference">hover</el-button>
                            </el-popover>
                            <div class="bottom clearfix" >
                              <div style="width: 100%; text-align:center;"  v-if="islogin">
                                <el-button type="primary" size="mini" @click="editProduct(item.foodId)" :disabled="disable" >编辑</el-button>
                              </div>
                            </div>
                          </div>
                        </div>
                      </el-card>
                    </el-col>
                  </el-row>
                </div>
                <div style="width: 100%; text-align:center; position:sticky; bottom:0;"  v-if="islogin">
                  <el-button type="success" round @click="addProduct()"><i class="el-icon-plus"></i></el-button>
                </div>
                <span style="height: 5em;"></span>
                <div id="pager" class="pager01">
                  <el-pagination
                  @current-change="CurrentChange"
                  background layout="total,  prev, pager, next, jumper"
                  :total="goodsList.length"
                  :page-size="4"
                  :current-page.sync="page.currentPage"
                  >
                  </el-pagination>
                </div>
              </div>
            </el-main>
        </el-container>
    </el-container>
</template>

<script>
import BrowseFoodByShopID from '@/services/BrowseFoodByShopID'
import showViewInfoService from '@/services/showViewInfoService'
import commonaside from '../components/commonaside.vue'
import commonheader from '../components/commonheader.vue'
export default {
  components: {
    commonaside,
    commonheader
  },

  name: 'BrowseFoodByShopID',
  data () {
    return {
      page: {
        pageSize: 4,
        currentPage: 1,
        total: 0
      },
      shopInfo: {
      },
      goodsList: [{
      }],
      islogin: 0,
      userInfo: {
        userId: '1',
        userIsFoodMerchant: 5
      },
      disable: false
    }
  },
  created () {
    this.islogin = this.$store.state.token !== ''
    this.getUserInfo()
    this.getShopGoodsList()
  },
  methods: {
    // 获取商品列表
    async getShopGoodsList () {
      try {
        const response = await BrowseFoodByShopID.getMyShopGoodsList(this.$route.params.id, {
          headers: {'Authorization': this.$store.state.token}
        })
        this.goodsList = response.data.data.shopFood.foodList
        this.shopInfo = response.data.data.shopFood
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          console.log('Network Error')
          this.error = 'Network Error'
        } else {
          this.error = error.response.data.error
          console.log(error.response.data.error)
        }
      }
    },
    async getUserInfo () {
      if (!this.islogin) {
        return
      }
      try {
        const response = await showViewInfoService.getInfo({
          headers: {'Authorization': this.$store.state.token}
        })
        this.userInfo = response.data.data.user
        if (this.userInfo.userIsFoodMerchant === 0 || this.userInfo.userIsFoodMerchant === 1 || this.userInfo.userIsFoodMerchant === 3) {
          this.$router.go(-1)
          this.$message({
            showClose: true,
            message: '用户非食品商家,无权访问我的店铺',
            type: 'error'
          })
        }
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.error = 'Network Error'
        } else {
          this.error = error.response.data.error
        }
      }
    },
    pages () {
      const pages = []
      this.goodsList.forEach((item, index) => {
        const page = Math.floor(index / 2)
        if (!pages[page]) {
          pages[page] = []
        }
        pages[page].push(item)
      })
      return pages
    },
    handleCurrentChange (val) {
      var thispage = this
      thispage.currentpage = val
      thispage.initPage()
    },
    CurrentChange (currentPage) {
      this.page.currentPage = currentPage
    },
    editProduct (proId) {
      this.$router.push('/modifyfood/' + this.$route.params.id + '/' + proId)
    },
    addProduct () {
      this.$router.push('/' + this.$route.params.id + '/addfood')
    },
    goComment () {
      this.$router.push('/foodshops/' + this.$route.params.id + '/comments')
    },
    goOrders () {
      this.$router.push('/MerFoodOrderManage/' + this.$route.params.id)
    }
  }
}

</script>

<style>
  .time {
  font-size: 13px;
  color: #999;
  }
  .bottom {
  margin-top: 13px;
  line-height: 12px;
  }
  .clearfix:before,
  .clearfix:after {
      display: table;
      content: "";
  }
  .clearfix:after {
      clear: both
  }
  .image {
  width: 100%;
  display: block;
  }
  .foodrow {
  margin-bottom: 20px;
  display: flex;
  flex-wrap: wrap
  }
  .foodrow .foodcol {
  border-radius: 4px;
  align-items: stretch;
  margin-bottom: 0px;
  margin-top: 20px;
  }
  .el-card{
    height: 100%;
    min-width: 100%;
    transition: all .5s;
  }
  .el-header {
  background-color: #333;
  }
  .el-main {
    padding-top: 0;
  }
  .pager01{
    left:0;
    bottom: 0;
    width:100%;
    height:50px;
    text-align: center;
    list-style: none;
    padding-top:8px;
  }
</style>
